install.packages("signal")
library(signal)


stats <- matrix(nrow=length(df.list), ncol=3)
colnames(stats) <- c('name', 'mean', 'sd')
stats[,1] <- ls(pattern = "ws_cricket_.*")

#put in band pass filter here
#allows specified frequencies to 	pass: low end cutoff removes electrical 	noise associated with wire sway and 	
#biological artifacts					-high end cutoff eliminates tissue 		noise at the electrode site	

install.packages('seewave')
library(seewave)



for (i in 1:length(df.list)){
  df.list[[i]] <- df.list[[i]][[2]]
  stats[i,2] <- mean(abs(df.list[[i]]))
  stats[i,3] <- sd(abs(df.list[[i]]))
  df.list[[i]] <- as.emg(df.list[[i]])
}
#start work for FIRST COLUMN OF DATA HERE*************************
#***************
################
###########
lowCutoff <- 10;
highCutoff <- 450;
filterOrder <- 10;
Fs <- 1000;
cutoffFrequencies <- c(lowCutoff/(Fs/2),highCutoff/(Fs/2));


for (i in 1:length(df.list)){
  df.list[[i]] <- df.list[[i]][[1]]
  }
 

highPass <- butter(filterOrder, cutoffFrequencies, "pass");
df.list_filtered <- df.list
#abs(as.numeric(df.list_filtered[[1]]))
#df.list_filtered[[1]]
for (i in 1:length(df.list)){
  df.list_filtered[[i]] <- filter(highPass,df.list_filtered[[i]])
 
}
class(df.list_filtered[[1]])
for (i in 1:length(df.list)){
   #Rectifying and Finalizing the Signal
  df.list_filtered[[i]] <- abs(as.numeric(df.list_filtered[[i]]));  
}

detections_filtered <- list()
keys_filtered <- matrix(nrow = length(df.list_filtered), ncol = 4)
stats_filtered <- matrix(nrow=length(df.list_filtered), ncol=3)
colnames(stats_filtered) <- c('name', 'mean', 'sd')
stats_filtered[,1] <- stats[,1]
class(df.list_filtered[[1]])

for (i in 1:length(df.list_filtered)){
  df.list_filtered[[i]] <- as.numeric(df.list_filtered[[i]])
  stats_filtered[i,2] <- mean(abs(df.list_filtered[[i]]))
  stats_filtered[i,3] <- sd(abs(df.list_filtered[[i]]))
}
df.list_filtered_keys <- df.list_filtered
for (i in 1:length(df.list_filtered)){
  df.list_filtered_keys[[i]] <- as.emg(as.numeric(df.list_filtered[[i]]))
  print(i)
  detections_filtered[[i]] <- onoff_bonato(df.list_filtered_keys[[i]], sigma_n = as.numeric(stats_filtered[i,3]),
                                           Pfa = 0.05, m = 200, r0 = 40, minL = 4000)
}

for (i in 1:length(df.list_filtered)){
  keys_filtered[i,] <- unique(c(1+which(diff(detections_filtered[[i]])!=0), length(detections_filtered[[i]])))[1:4]
}
walks.list<- list()
for (i in 1:length(df.list_filtered)){
  walks.list[[i]] <- list(df.list_filtered[[i]][keys_filtered[i,1]:keys_filtered[i,2]],
                          df.list_filtered[[i]][keys_filtered[i,3]:keys_filtered[i,4]])
  
}

stats_walks <- matrix(nrow=length(df.list_filtered), ncol=12)
colnames(stats_walks) <- c('name', 'mean_walk1', 'sd_walk1', 'mean_walk2', 'sd_walk2', 
                           'median_walk1', 'median_walk2', 'max_walk1', 'max_walk2', 'min_walk1', 'min_walk2', 'max_MVIC')
stats_walks[,1] <- stats[,1]



for (i in 1:length(walks.list)){
  stats_walks[i,2] <- mean(walks.list[[i]][[1]])
  stats_walks[i,4] <- mean(walks.list[[i]][[2]])
  stats_walks[i,3] <- sd(walks.list[[i]][[1]])
  stats_walks[i,5] <- sd(walks.list[[i]][[2]])
  stats_walks[i,6] <- median(walks.list[[i]][[2]])
  stats_walks[i,7] <- median(walks.list[[i]][[1]])
  stats_walks[i,8] <- max(walks.list[[i]][[2]])
  stats_walks[i,9] <- max(walks.list[[i]][[1]])
  stats_walks[i,10] <- min(walks.list[[i]][[2]])
  stats_walks[i,11] <- min(walks.list[[i]][[1]])
  stats_walks[i,12] <- max(df.list_filtered[[i]][1:keys_filtered[i,1]])
  print(i)
}
stats_walks
#normalization
norm.walks.list <- walks.list
for (i in 1:length(norm.walks.list)){
  norm.walks.list[[i]][[1]] <- ((walks.list[[i]][[1]])/as.numeric(stats_walks[i,12]))*100
  norm.walks.list[[i]][[2]] <- ((walks.list[[i]][[2]])/as.numeric(stats_walks[i,12]))*100
  
}
#smoothing, MA window 200
smooth.norm.walks.list <- norm.walks.list
for (i in 1:length(norm.walks.list)){
  smooth.norm.walks.list[[i]][[1]] <- envelope(as.emg(norm.walks.list[[i]][[1]]), method = "MA", wsize = 200)
  smooth.norm.walks.list[[i]][[2]] <- envelope(as.emg(norm.walks.list[[i]][[2]]), method = "MA", wsize = 200)
  
}

plot(envelope(as.emg(norm.walks.list[[17]][[1]]), method = "MA", wsize = 200), type = 'l')

install.packages("dtw")
library(dtw)

test.stats[,1] <- stats_walks[,1]
for (i in 1:length(df.list_filtered)){
  test.stats[i,2] <- mean(test.walks[[i]])
  test.stats[i,3] <- sd(test.walks[[i]])
  test.stats[i,4] <- mean(test.walks[[i+33]])
  test.stats[i,5] <- sd(test.walks[[i+33]])
  #median amp from fft?
  test.stats[i,8] <- cohen.d(test.walks[[i]],test.walks[[i+33]])$estimate
  #test.stats[,9] <- cohen.d(test.walks[[i]],test.walks[[i+33]])$conf.int
  #test.stats[i,9] <- dtw(test.walks[[i]],test.walks[[i+33]],keep=TRUE)$normalizedDistance
  #link for explaining cohen's d
}
#add in the median
for (i in 1:length(df.list_filtered)){
  test.stats[i,6] <- median(test.walks[[i]])
  test.stats[i,7] <- median(test.walks[[i+33]])
}

for (i in 3:6){
  test.stats[i,9] <- dtw(test.walks[[i]],test.walks[[i+33]],keep=TRUE)$normalizedDistance
  
}
test.stats.corr <- as.numeric(test.stats[,8])
test.stats.corr <- test.stats.corr / sqrt(test.stats.corr^2 + 4)
test.statsv1 <- cbind(test.stats, test.stats.corr)
test.stats[7,9] <- dtw(test.walks[[7]],test.walks[[7+33]],keep=TRUE)$normalizedDistance
for (i in 1:length(df.list_filtered)){
  test.stats[i,9] <- dtw(test.walks[[i]],test.walks[[i+33]],keep=TRUE)$normalizedDistance
}
dtw.test <- list()
test.stats
for (i in 1:length(test.stats)){
  dtw.test[[i]] <- lapply(split(test.walks[[i]],1:100),                      ## I split y in 100 chnucks
                          function(z)dtw(test.walks[[i+33]],z,keep=TRUE)$normalizedDistance)
  #dtw.test[[i]] <- as.data.frame(dtw.test[[i]])
  #test.stats[i,12] <- mean(dtw.test[[i]][,1])
}

dtw.test <- lapply(split(test.walks[[33]],1:100),                      ## I split y in 100 chnucks
       function(z)dtw(test.walks[[66]],z,keep=TRUE)$normalizedDistance)

dtw.test <- as.data.frame(dtw.test)
test.stats[33,9] <- mean(dtw.test[,1])
rm(dtw.test)

test.statsv2 <- matrix(nrow=length(df.list_filtered), ncol=8)
colnames(test.statsv2) <- c('name', 'meanfreq_walk1', 'sd_walk1', 'meanfreq_walk2', 'sd_walk2', 
                          'medianfreq_walk1', 'medianfreq_walk2', 'Granger Test Pr(>F')

test.statsv2[,1] <- stats_walks[,1]

for (i in 1:length(df.list_filtered)){
  test.statsv2[i,2] <- specprop(spec(test.walks[[i]], f = 1000), f = 1000)$mean
  test.statsv2[i,3] <- specprop(spec(test.walks[[i]], f = 1000), f = 1000)$sd
  test.statsv2[i,4] <- specprop(spec(test.walks[[i+33]], f = 1000), f = 1000)$mean
  test.statsv2[i,5] <- specprop(spec(test.walks[[i+33]], f = 1000), f = 1000)$sd
  test.statsv2[i,6] <- specprop(spec(test.walks[[i]], f = 1000), f = 1000)$median
  test.statsv2[i,7] <- specprop(spec(test.walks[[i+33]], f = 1000), f = 1000)$median  
  test.statsv2[i,8] <- grangertest(test.walks[[i]], test.walks[[i+33]])$Pr[2]
}
specprop(spec(test.walks[[1]], f = 1000), f = 1000)$mean

grangertest(test.walks[[1]], test.walks[[1+33]])$Pr[2]

install.packages("lmtest")
library(lmtest)
install.packages("seewave")
library(seewave)
meanspec(walks.list[[1]][[2]], f = 1000, identity = TRUE)
#function is based on fft
specprop(walks.list[[1]][[2]], f = 1000)

test.walks_df <- as.data.frame()
#GROUP ANALYSIS
#45 deg_groups
#1-5,12-18,24,25,29,31,33,39-45,52-57,59-61,63,65
install.packages('rlist')
library(rlist)
KB45 <- c(1:5,12:18,24,25,29,31,33,39:44,52:56,59:61,63,65)
test.walks_45 <- list()
test.walks_90 <- list()
for (i in KB45){
  test.walks_45 <- list.append(test.walks_45, test.walks[[i]])
  print(i)
}
length(KB90)
KB90 <- setdiff(1:66, KB45)
for (i in KB90){
  test.walks_90 <- list.append(test.walks_90, test.walks[[i]])
  print(i)
}
test.walks_45_all <- unlist(test.walks_45)
test.walks_90_all <- unlist(test.walks_90)
mean(test.walks_45_all)#[1] 15.89563
mean(test.walks_90_all)#[1] 15.64876

cohen.d(test.walks_45_all, test.walks_90_all)
means_45 <- c(as.vector(test.statsv1[-c(1:5,12:18,24,25,29,31,33),4]),as.vector(test.statsv1[c(1:5,12:18,24,25,29,31,33),2]))
means_90 <- c(as.vector(test.statsv1[c(1:5,12:18,24,25,29,31,33),4]),as.vector(test.statsv1[-c(1:5,12:18,24,25,29,31,33),2]))

means_45v2 <- c(as.vector(test.statsv2[c(1:5,12:18,24,25,29,31,33),2]),as.vector(test.statsv2[-c(1:5,12:18,24,25,29,31,33),4]))
means_90v2 <- c(as.vector(test.statsv2[c(1:5,12:18,24,25,29,31,33),4]),as.vector(test.statsv2[-c(1:5,12:18,24,25,29,31,33),2]))

mean(as.numeric(means_90))
t.test(as.numeric(means_45), as.numeric(means_90))#.75
#using welch's t test as variances are not assumed to be equal and n > 30
t.test(as.numeric(means_45v2), as.numeric(means_90v2))# 0.04889
t.test(as.numeric(means_45v2), as.numeric(means_90v2), paired = TRUE)#p-value = 0.01799

#type I error rate kinda high, 
#If the significance level for a given experiment is ??, the experimentwise significance
#level will increase exponentially (significance decreases) as the number of tests increases.
#More precisely, assuming all tests are independent, if n tests are performed, the
#experimentwise significance level will be given by 1 ??? (1 ??? ??)^n ??? n?? when ?? is small 
kruskal.test(as.numeric(means_45v2), as.numeric(means_90v2))#p-value = 0.4667, makes sense because data did come from
#identical populations, rather than ones with different variances
kruskal.test(test.walks_45_all[1:450000], test.walks_90_all[1:450000])#p-value = 0.4997
#for whole population, not just selected sub groups, had to have same lengths

#don't want to use mann whitney test b/c assumptipon in that test is that Samples	are	random	and	independent	(no	before/after tests)
#paired = true so we're usiong wilcox test rather than mann whitney; wilcox is non paramteric alt to t test 
#so we can use it if there uis no compelling reason to assume a Gaussian distribution before examining the data,
#since shapiro tests cannot reject null hypothesis that it comes from normal dist, we have to look into it more

wilcox.test(as.numeric(means_45v2), as.numeric(means_90v2), paired = TRUE)#0.02791
c(mean(as.numeric(means_45v2)), mean(as.numeric(means_90v2)))#[1] 9.799415 9.354456
c(mean(as.numeric(means_45)), mean(as.numeric(means_90)))#[1] 15.82712 15.40850
cohen.d(as.numeric(means_45v2), as.numeric(means_90v2))# d estimate: 0.4943276
shapiro.test(as.numeric(means_45v2))#p-value = 0.8792#testing data normality, both sample mean distributions pass
shapiro.test(as.numeric(means_90v2))#p-value = 0.7906

qqplot(means_45v2, means_90v2)#plot against each other
#The central limit theorem tells us that no matter what distribution things have, the sampling distribution tends to 
#be normal if the sample is large enough (n > 30).
par(mfrow = c(1,2))
qqnorm(means_45v2, ylim = c(8,12))
qqnorm(means_90v2, ylim = c(8,12))
round(as.numeric(means_45v2), digits = 3)
round(as.numeric(means_90v2), digits = 3)

# as one-factor ANOVA, is an extension of independent two-samples t-test for comparing means in a situation where there are more than two groups
# so dont need to use one way anova since we're looking at 2 groups: 45 adn 90
grangertest(test.walks_45_all, test.walks_90_all)
paste(as.character(round(as.numeric(means_90v2), digits = 3)), collapse=", ")

#build quick t tests for shorter lengths
#carrying 45 degree KB first
t.test(as.numeric(means_45v2[1:17]), as.numeric(means_90v2[1:17]))# 0.06312#mean of x, mean of y:  9.753726  9.202384 
#90 degrees first
t.test(as.numeric(means_45v2[18:33]), as.numeric(means_90v2[18:33]))# 0.3445#mean of x, mean of y:  9.847958  9.516034 
#might use non parametric because N<30?
#using paired t tests cuz vigotnsky did
t.test(as.numeric(means_45v2[1:17]), as.numeric(means_90v2[1:17]), paired = TRUE)# 0.0325
t.test(as.numeric(means_45v2[18:33]), as.numeric(means_90v2[18:33]), paired = TRUE)# 0.2458

wilcox.test(as.numeric(means_45v2[1:17]), as.numeric(means_90v2[1:17]), paired = TRUE)#0.03954
wilcox.test(as.numeric(means_45v2[18:33]), as.numeric(means_90v2[18:33]), paired = TRUE)#0.2979
par(mfrow = c(1,2))
plot(density(as.numeric(means_45v2)))
plot(density(as.numeric(means_90v2)))#looks fairly normal

par(mfrow = c(1,2))
qqnorm(as.numeric(means_45v2))
qqnorm(as.numeric(means_90v2))#looks fairly normal

par(mfrow = c(1,2))
plot(density(as.numeric(means_45v2[1:17])))
plot(density(as.numeric(means_90v2[1:17])))#looks fairly normal

par(mfrow = c(1,2))
plot(density(as.numeric(means_45v2[18:33])))
plot(density(as.numeric(means_90v2[18:33])))#looks fairly normal

par(mfrow = c(1,2))
qqnorm(as.numeric(means_45v2[1:17]))
qqnorm(as.numeric(means_90v2[1:17]))

par(mfrow = c(1,2))
qqnorm(as.numeric(means_45v2[18:33]))
qqnorm(as.numeric(means_90v2[18:33]))


grangertest(as.numeric(means_45v2), as.numeric(means_90v2))#.7941
#granger test only useful intra subjects for predicting when one time series predicts future lagged values of another


dtw(as.numeric(means_45v2),as.numeric(means_90v2),keep=TRUE)$normalizedDistance#.4267
cohen.d(as.numeric(means_45v2), as.numeric(means_90v2))#d estimate: 0.4943276 (small)
